DefaultDocument (Xerces2 Implementation)
Date: 2016-02-19

org.apache.xerces.impl.xs.opti

## Class DefaultDocument

- java.lang.Object
- - org.apache.xerces.impl.xs.opti.DefaultNode
  - - org.apache.xerces.impl.xs.opti.NodeImpl
    - - org.apache.xerces.impl.xs.opti.DefaultDocument

- All Implemented Interfaces:
    org.w3c.dom.Document, org.w3c.dom.Node
  Direct Known Subclasses:
    SchemaDOM

      public class DefaultDocument
      extends NodeImpl
      implements org.w3c.dom.Document

  Version:
    $Id: DefaultDocument.java 705596 2008-10-17 13:05:10Z mrglavas $
  Author:
    Rahul Srivastava, Sun Microsystems Inc.

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    - ### Fields inherited from interface org.w3c.dom.Node

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultDocument()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `org.w3c.dom.Node` | `adoptNode(org.w3c.dom.Node source)` DOM Level 3
    `org.w3c.dom.Attr` | `createAttribute(java.lang.String name)` Creates an `Attr` of the given name.
    `org.w3c.dom.Attr` | `createAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName)` Creates an attribute of the given qualified name and namespace URI.
    `org.w3c.dom.CDATASection` | `createCDATASection(java.lang.String data)` Creates a `CDATASection` node whose value is the specified string.
    `org.w3c.dom.Comment` | `createComment(java.lang.String data)` Creates a `Comment` node given the specified string.
    `org.w3c.dom.DocumentFragment` | `createDocumentFragment()` Creates an empty `DocumentFragment` object.
    `org.w3c.dom.Element` | `createElement(java.lang.String tagName)` Creates an element of the type specified.
    `org.w3c.dom.Element` | `createElementNS(java.lang.String namespaceURI, java.lang.String qualifiedName)` Creates an element of the given qualified name and namespace URI.
    `org.w3c.dom.EntityReference` | `createEntityReference(java.lang.String name)` Creates an `EntityReference` object.
    `org.w3c.dom.ProcessingInstruction` | `createProcessingInstruction(java.lang.String target, java.lang.String data)` Creates a `ProcessingInstruction` node given the specified name and data strings.
    `org.w3c.dom.Text` | `createTextNode(java.lang.String data)` Creates a `Text` node given the specified string.
    `org.w3c.dom.DocumentType` | `getDoctype()` The Document Type Declaration (see `DocumentType`) associated with this document.
    `org.w3c.dom.Element` | `getDocumentElement()` This is a convenience attribute that allows direct access to the child node that is the document element of the document.
    `java.lang.String` | `getDocumentURI()` The location of the document or `null` if undefined.
    `org.w3c.dom.DOMConfiguration` | `getDomConfig()` The configuration used when `Document.normalizeDocument` is invoked.
    `org.w3c.dom.Element` | `getElementById(java.lang.String elementId)` Returns the `Element` that has an ID attribute with the given value.
    `org.w3c.dom.NodeList` | `getElementsByTagName(java.lang.String tagname)` Returns a `NodeList` of all the `Elements` in document order with a given tag name and are contained in the document.
    `org.w3c.dom.NodeList` | `getElementsByTagNameNS(java.lang.String namespaceURI, java.lang.String localName)` Returns a `NodeList` of all the `Elements` with a given local name and namespace URI in document order.
    `org.w3c.dom.DOMImplementation` | `getImplementation()` The `DOMImplementation` object that handles this document.
    `java.lang.String` | `getInputEncoding()` An attribute specifying the encoding used for this document at the time of the parsing.
    `java.lang.String` | `getNodeName()` The name of this node, depending on its type; see the table above.
    `boolean` | `getStrictErrorChecking()` An attribute specifying whether errors checking is enforced or not.
    `java.lang.String` | `getXmlEncoding()` public void setInputEncoding(String actualEncoding){ throw new DOMException(DOMException.NOT_SUPPORTED_ERR, "Method not supported"); }
    `boolean` | `getXmlStandalone()` An attribute specifying, as part of the XML declaration, whether this document is standalone.
    `java.lang.String` | `getXmlVersion()` An attribute specifying, as part of the XML declaration, the version number of this document.
    `org.w3c.dom.Node` | `importNode(org.w3c.dom.Node importedNode, boolean deep)` Imports a node from another document to this document, without altering or removing the source node from the original document; this method creates a new copy of the source node.
    `void` | `normalizeDocument()` DOM Level 3
    `org.w3c.dom.Node` | `renameNode(org.w3c.dom.Node n, java.lang.String namespaceURI, java.lang.String name)` DOM Level 3
    `void` | `setDocumentURI(java.lang.String documentURI)` The location of the document or `null` if undefined.
    `void` | `setStrictErrorChecking(boolean strictErrorChecking)` An attribute specifying whether errors checking is enforced or not.
    `void` | `setXmlStandalone(boolean standalone)` An attribute specifying, as part of the XML declaration, whether this document is standalone.
    `void` | `setXmlVersion(java.lang.String version)` An attribute specifying, as part of the XML declaration, the version number of this document.

    - ### Methods inherited from class org.apache.xerces.impl.xs.opti.NodeImpl

      `getLocalName, getNamespaceURI, getNodeType, getPrefix, getReadOnly, setReadOnly, toString`

    - ### Methods inherited from class org.apache.xerces.impl.xs.opti.DefaultNode

      `appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getNextSibling, getNodeValue, getOwnerDocument, getParentNode, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.w3c.dom.Node

      `appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeType, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`

- - ### Constructor Detail

    - #### DefaultDocument

          public DefaultDocument()

  - ### Method Detail

    - #### getNodeName

          public java.lang.String getNodeName()

      Description copied from interface: `org.w3c.dom.Node`
      The name of this node, depending on its type; see the table above.
      Specified by:
        `getNodeName` in interface `org.w3c.dom.Node`
      Overrides:
        `getNodeName` in class `NodeImpl`

    - #### getDoctype

          public org.w3c.dom.DocumentType getDoctype()

      Description copied from interface: `org.w3c.dom.Document`
      The Document Type Declaration (see `DocumentType`) associated with this document. For XML documents without a document type declaration this returns `null`. For HTML documents, a `DocumentType` object may be returned, independently of the presence or absence of document type declaration in the HTML document.
      This provides direct access to the `DocumentType` node, child node of this `Document`. This node can be set at document creation time and later changed through the use of child nodes manipulation methods, such as `Node.insertBefore`, or `Node.replaceChild`. Note, however, that while some implementations may instantiate different types of `Document` objects supporting additional features than the "Core", such as "HTML" [DOM Level 2 HTML] , based on the `DocumentType` specified at creation time, changing it afterwards is very unlikely to result in a change of the features supported.
      Specified by:
        `getDoctype` in interface `org.w3c.dom.Document`

    - #### getImplementation

          public org.w3c.dom.DOMImplementation getImplementation()

      Description copied from interface: `org.w3c.dom.Document`
      The `DOMImplementation` object that handles this document. A DOM application may use objects from multiple implementations.
      Specified by:
        `getImplementation` in interface `org.w3c.dom.Document`

    - #### getDocumentElement

          public org.w3c.dom.Element getDocumentElement()

      Description copied from interface: `org.w3c.dom.Document`
      This is a convenience attribute that allows direct access to the child node that is the document element of the document.
      Specified by:
        `getDocumentElement` in interface `org.w3c.dom.Document`

    - #### getElementsByTagName

          public org.w3c.dom.NodeList getElementsByTagName(java.lang.String tagname)

      Description copied from interface: `org.w3c.dom.Document`
      Returns a `NodeList` of all the `Elements` in document order with a given tag name and are contained in the document.
      Specified by:
        `getElementsByTagName` in interface `org.w3c.dom.Document`
      Parameters:
        `tagname` - The name of the tag to match on. The special value "*" matches all tags. For XML, the `tagname` parameter is case-sensitive, otherwise it depends on the case-sensitivity of the markup language in use.
      Returns:
        A new `NodeList` object containing all the matched `Elements`.

    - #### getElementsByTagNameNS

          public org.w3c.dom.NodeList getElementsByTagNameNS(java.lang.String namespaceURI,
                                                    java.lang.String localName)

      Description copied from interface: `org.w3c.dom.Document`
      Returns a `NodeList` of all the `Elements` with a given local name and namespace URI in document order.
      Specified by:
        `getElementsByTagNameNS` in interface `org.w3c.dom.Document`
      Parameters:
        `namespaceURI` - The namespace URI of the elements to match on. The special value `"*"` matches all namespaces.
        `localName` - The local name of the elements to match on. The special value "*" matches all local names.
      Returns:
        A new `NodeList` object containing all the matched `Elements`.

    - #### getElementById

          public org.w3c.dom.Element getElementById(java.lang.String elementId)

      Description copied from interface: `org.w3c.dom.Document`
      Returns the `Element` that has an ID attribute with the given value. If no such element exists, this returns `null` . If more than one element has an ID attribute with that value, what is returned is undefined.
      The DOM implementation is expected to use the attribute `Attr.isId` to determine if an attribute is of type ID.

      Note: Attributes with the name "ID" or "id" are not of type ID unless so defined.

      Specified by:
        `getElementById` in interface `org.w3c.dom.Document`
      Parameters:
        `elementId` - The unique `id` value for an element.
      Returns:
        The matching element or `null` if there is none.

    - #### importNode

          public org.w3c.dom.Node importNode(org.w3c.dom.Node importedNode,
                                    boolean deep)
                                      throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Imports a node from another document to this document, without altering or removing the source node from the original document; this method creates a new copy of the source node. The returned node has no parent; (`parentNode` is `null`).
      For all nodes, importing a node creates a node object owned by the importing document, with attribute values identical to the source node's `nodeName` and `nodeType`, plus the attributes related to namespaces (`prefix`, `localName`, and `namespaceURI`). As in the `cloneNode` operation, the source node is not altered. User data associated to the imported node is not carried over. However, if any `UserDataHandlers` has been specified along with the associated data these handlers will be called with the appropriate parameters before this method returns.
      Additional information is copied as appropriate to the `nodeType`, attempting to mirror the behavior expected if a fragment of XML or HTML source was copied from one document to another, recognizing that the two documents may have different DTDs in the XML case. The following list describes the specifics for each type of node.
      ATTRIBUTE_NODE
        The `ownerElement` attribute is set to `null` and the `specified` flag is set to `true` on the generated `Attr`. The descendants of the source `Attr` are recursively imported and the resulting nodes reassembled to form the corresponding subtree. Note that the `deep` parameter has no effect on `Attr` nodes; they always carry their children with them when imported.
      DOCUMENT_FRAGMENT_NODE
        If the `deep` option was set to `true`, the descendants of the source `DocumentFragment` are recursively imported and the resulting nodes reassembled under the imported `DocumentFragment` to form the corresponding subtree. Otherwise, this simply generates an empty `DocumentFragment`.
      DOCUMENT_NODE
        `Document` nodes cannot be imported.
      DOCUMENT_TYPE_NODE
        `DocumentType` nodes cannot be imported.
      ELEMENT_NODE
        Specified attribute nodes of the source element are imported, and the generated `Attr` nodes are attached to the generated `Element`. Default attributes are not copied, though if the document being imported into defines default attributes for this element name, those are assigned. If the `importNode` `deep` parameter was set to `true`, the descendants of the source element are recursively imported and the resulting nodes reassembled to form the corresponding subtree.
      ENTITY_NODE
        `Entity` nodes can be imported, however in the current release of the DOM the `DocumentType` is readonly. Ability to add these imported nodes to a `DocumentType` will be considered for addition to a future release of the DOM.On import, the `publicId`, `systemId`, and `notationName` attributes are copied. If a `deep` import is requested, the descendants of the the source `Entity` are recursively imported and the resulting nodes reassembled to form the corresponding subtree.
      ENTITY_REFERENCE_NODE
        Only the `EntityReference` itself is copied, even if a `deep` import is requested, since the source and destination documents might have defined the entity differently. If the document being imported into provides a definition for this entity name, its value is assigned.
      NOTATION_NODE
        `Notation` nodes can be imported, however in the current release of the DOM the `DocumentType` is readonly. Ability to add these imported nodes to a `DocumentType` will be considered for addition to a future release of the DOM.On import, the `publicId` and `systemId` attributes are copied. Note that the `deep` parameter has no effect on this type of nodes since they cannot have any children.
      PROCESSING_INSTRUCTION_NODE
        The imported node copies its `target` and `data` values from those of the source node.Note that the `deep` parameter has no effect on this type of nodes since they cannot have any children.
      TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE
        These three types of nodes inheriting from `CharacterData` copy their `data` and `length` attributes from those of the source node.Note that the `deep` parameter has no effect on these types of nodes since they cannot have any children.
      Specified by:
        `importNode` in interface `org.w3c.dom.Document`
      Parameters:
        `importedNode` - The node to import.
        `deep` - If `true`, recursively import the subtree under the specified node; if `false`, import only the node itself, as explained above. This has no effect on nodes that cannot have any children, and on `Attr`, and `EntityReference` nodes.
      Returns:
        The imported node that belongs to this `Document`.
      Throws:
        `org.w3c.dom.DOMException` - NOT_SUPPORTED_ERR: Raised if the type of node being imported is not supported.
        INVALID_CHARACTER_ERR: Raised if one of the imported names is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute. This may happen when importing an XML 1.1 [XML 1.1] element into an XML 1.0 document, for instance.

    - #### createElement

          public org.w3c.dom.Element createElement(java.lang.String tagName)
                                            throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Creates an element of the type specified. Note that the instance returned implements the `Element` interface, so attributes can be specified directly on the returned object.
      In addition, if there are known attributes with default values, `Attr` nodes representing them are automatically created and attached to the element.
      To create an element with a qualified name and namespace URI, use the `createElementNS` method.
      Specified by:
        `createElement` in interface `org.w3c.dom.Document`
      Parameters:
        `tagName` - The name of the element type to instantiate. For XML, this is case-sensitive, otherwise it depends on the case-sensitivity of the markup language in use. In that case, the name is mapped to the canonical form of that markup by the DOM implementation.
      Returns:
        A new `Element` object with the `nodeName` attribute set to `tagName`, and `localName`, `prefix`, and `namespaceURI` set to `null`.
      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified name is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.

    - #### createDocumentFragment

          public org.w3c.dom.DocumentFragment createDocumentFragment()

      Description copied from interface: `org.w3c.dom.Document`
      Creates an empty `DocumentFragment` object.
      Specified by:
        `createDocumentFragment` in interface `org.w3c.dom.Document`
      Returns:
        A new `DocumentFragment`.

    - #### createTextNode

          public org.w3c.dom.Text createTextNode(java.lang.String data)

      Description copied from interface: `org.w3c.dom.Document`
      Creates a `Text` node given the specified string.
      Specified by:
        `createTextNode` in interface `org.w3c.dom.Document`
      Parameters:
        `data` - The data for the node.
      Returns:
        The new `Text` object.

    - #### createComment

          public org.w3c.dom.Comment createComment(java.lang.String data)

      Description copied from interface: `org.w3c.dom.Document`
      Creates a `Comment` node given the specified string.
      Specified by:
        `createComment` in interface `org.w3c.dom.Document`
      Parameters:
        `data` - The data for the node.
      Returns:
        The new `Comment` object.

    - #### createCDATASection

          public org.w3c.dom.CDATASection createCDATASection(java.lang.String data)
                                                      throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Creates a `CDATASection` node whose value is the specified string.
      Specified by:
        `createCDATASection` in interface `org.w3c.dom.Document`
      Parameters:
        `data` - The data for the `CDATASection` contents.
      Returns:
        The new `CDATASection` object.
      Throws:
        `org.w3c.dom.DOMException` - NOT_SUPPORTED_ERR: Raised if this document is an HTML document.

    - #### createProcessingInstruction

          public org.w3c.dom.ProcessingInstruction createProcessingInstruction(java.lang.String target,
                                                                      java.lang.String data)
                                                                        throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Creates a `ProcessingInstruction` node given the specified name and data strings.
      Specified by:
        `createProcessingInstruction` in interface `org.w3c.dom.Document`
      Parameters:
        `target` - The target part of the processing instruction.Unlike `Document.createElementNS` or `Document.createAttributeNS`, no namespace well-formed checking is done on the target name. Applications should invoke `Document.normalizeDocument()` with the parameter " namespaces" set to `true` in order to ensure that the target name is namespace well-formed.
        `data` - The data for the node.
      Returns:
        The new `ProcessingInstruction` object.
      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified target is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NOT_SUPPORTED_ERR: Raised if this document is an HTML document.

    - #### createAttribute

          public org.w3c.dom.Attr createAttribute(java.lang.String name)
                                           throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Creates an `Attr` of the given name. Note that the `Attr` instance can then be set on an `Element` using the `setAttributeNode` method.
      To create an attribute with a qualified name and namespace URI, use the `createAttributeNS` method.
      Specified by:
        `createAttribute` in interface `org.w3c.dom.Document`
      Parameters:
        `name` - The name of the attribute.
      Returns:
        A new `Attr` object with the `nodeName` attribute set to `name`, and `localName`, `prefix`, and `namespaceURI` set to `null`. The value of the attribute is the empty string.
      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified name is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.

    - #### createEntityReference

          public org.w3c.dom.EntityReference createEntityReference(java.lang.String name)
                                                            throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Creates an `EntityReference` object. In addition, if the referenced entity is known, the child list of the `EntityReference` node is made the same as that of the corresponding `Entity` node.

      Note: If any descendant of the `Entity` node has an unbound namespace prefix, the corresponding descendant of the created `EntityReference` node is also unbound; (its `namespaceURI` is `null`). The DOM Level 2 and 3 do not support any mechanism to resolve namespace prefixes in this case.

      Specified by:
        `createEntityReference` in interface `org.w3c.dom.Document`
      Parameters:
        `name` - The name of the entity to reference.Unlike `Document.createElementNS` or `Document.createAttributeNS`, no namespace well-formed checking is done on the entity name. Applications should invoke `Document.normalizeDocument()` with the parameter " namespaces" set to `true` in order to ensure that the entity name is namespace well-formed.
      Returns:
        The new `EntityReference` object.
      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified name is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NOT_SUPPORTED_ERR: Raised if this document is an HTML document.

    - #### createElementNS

          public org.w3c.dom.Element createElementNS(java.lang.String namespaceURI,
                                            java.lang.String qualifiedName)
                                              throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Creates an element of the given qualified name and namespace URI.
      Per [XML Namespaces] , applications must use the value `null` as the namespaceURI parameter for methods if they wish to have no namespace.
      Specified by:
        `createElementNS` in interface `org.w3c.dom.Document`
      Parameters:
        `namespaceURI` - The namespace URI of the element to create.
        `qualifiedName` - The qualified name of the element type to instantiate.
      Returns:
        A new `Element` object with the following attributes:

        Attribute | Value
        --- | ---
        `Node.nodeName` | `qualifiedName`
        `Node.namespaceURI` | `namespaceURI`
        `Node.prefix` | prefix, extracted from `qualifiedName`, or `null` if there is no prefix
        `Node.localName` | local name, extracted from `qualifiedName`
        `Element.tagName` | `qualifiedName`

      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified `qualifiedName` is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NAMESPACE_ERR: Raised if the `qualifiedName` is a malformed qualified name, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, or if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace" [XML Namespaces] , or if the `qualifiedName` or its prefix is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/", or if the `namespaceURI` is "http://www.w3.org/2000/xmlns/" and neither the `qualifiedName` nor its prefix is "xmlns".
        NOT_SUPPORTED_ERR: Always thrown if the current document does not support the `"XML"` feature, since namespaces were defined by XML.

    - #### createAttributeNS

          public org.w3c.dom.Attr createAttributeNS(java.lang.String namespaceURI,
                                           java.lang.String qualifiedName)
                                             throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Document`
      Creates an attribute of the given qualified name and namespace URI.
      Per [XML Namespaces] , applications must use the value `null` as the `namespaceURI` parameter for methods if they wish to have no namespace.
      Specified by:
        `createAttributeNS` in interface `org.w3c.dom.Document`
      Parameters:
        `namespaceURI` - The namespace URI of the attribute to create.
        `qualifiedName` - The qualified name of the attribute to instantiate.
      Returns:
        A new `Attr` object with the following attributes:

        Attribute | Value
        --- | ---
        `Node.nodeName` | qualifiedName
        `Node.namespaceURI` | `namespaceURI`
        `Node.prefix` | prefix, extracted from `qualifiedName`, or `null` if there is no prefix
        `Node.localName` | local name, extracted from `qualifiedName`
        `Attr.name` | `qualifiedName`
        `Node.nodeValue` | the empty string

      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified `qualifiedName` is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NAMESPACE_ERR: Raised if the `qualifiedName` is a malformed qualified name, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace", if the `qualifiedName` or its prefix is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/", or if the `namespaceURI` is "http://www.w3.org/2000/xmlns/" and neither the `qualifiedName` nor its prefix is "xmlns".
        NOT_SUPPORTED_ERR: Always thrown if the current document does not support the `"XML"` feature, since namespaces were defined by XML.

    - #### getInputEncoding

          public java.lang.String getInputEncoding()

      Description copied from interface: `org.w3c.dom.Document`
      An attribute specifying the encoding used for this document at the time of the parsing. This is `null` when it is not known, such as when the `Document` was created in memory.
      Specified by:
        `getInputEncoding` in interface `org.w3c.dom.Document`

    - #### getXmlEncoding

          public java.lang.String getXmlEncoding()

      public void setInputEncoding(String actualEncoding){ throw new DOMException(DOMException.NOT_SUPPORTED_ERR, "Method not supported"); }
      Specified by:
        `getXmlEncoding` in interface `org.w3c.dom.Document`

    - #### getXmlStandalone

          public boolean getXmlStandalone()

      An attribute specifying, as part of the XML declaration, whether this document is standalone.
      This attribute represents the property [standalone] defined in .
      Specified by:
        `getXmlStandalone` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### setXmlStandalone

          public void setXmlStandalone(boolean standalone)

      An attribute specifying, as part of the XML declaration, whether this document is standalone.
      This attribute represents the property [standalone] defined in .
      Specified by:
        `setXmlStandalone` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### getXmlVersion

          public java.lang.String getXmlVersion()

      An attribute specifying, as part of the XML declaration, the version number of this document. This is `null` when unspecified.
      This attribute represents the property [version] defined in .
      Specified by:
        `getXmlVersion` in interface `org.w3c.dom.Document`
      Throws:
        `org.w3c.dom.DOMException` - NOT_SUPPORTED_ERR: Raised if the version is set to a value that is not supported by this `Document`.
      Since:
        DOM Level 3

    - #### setXmlVersion

          public void setXmlVersion(java.lang.String version)
                             throws org.w3c.dom.DOMException

      An attribute specifying, as part of the XML declaration, the version number of this document. This is `null` when unspecified.
      This attribute represents the property [version] defined in .
      Specified by:
        `setXmlVersion` in interface `org.w3c.dom.Document`
      Throws:
        `org.w3c.dom.DOMException` - NOT_SUPPORTED_ERR: Raised if the version is set to a value that is not supported by this `Document`.
      Since:
        DOM Level 3

    - #### getStrictErrorChecking

          public boolean getStrictErrorChecking()

      An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.
      Specified by:
        `getStrictErrorChecking` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### setStrictErrorChecking

          public void setStrictErrorChecking(boolean strictErrorChecking)

      An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.
      Specified by:
        `setStrictErrorChecking` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### getDocumentURI

          public java.lang.String getDocumentURI()

      The location of the document or `null` if undefined.
      Beware that when the `Document` supports the feature "HTML" , the href attribute of the HTML BASE element takes precedence over this attribute.
      Specified by:
        `getDocumentURI` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### setDocumentURI

          public void setDocumentURI(java.lang.String documentURI)

      The location of the document or `null` if undefined.
      Beware that when the `Document` supports the feature "HTML" , the href attribute of the HTML BASE element takes precedence over this attribute.
      Specified by:
        `setDocumentURI` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### adoptNode

          public org.w3c.dom.Node adoptNode(org.w3c.dom.Node source)
                                     throws org.w3c.dom.DOMException

      DOM Level 3
      Specified by:
        `adoptNode` in interface `org.w3c.dom.Document`
      Parameters:
        `source` - The node to move into this document.
      Returns:
        The adopted node, or `null` if this operation fails, such as when the source node comes from a different implementation.
      Throws:
        `org.w3c.dom.DOMException` - NOT_SUPPORTED_ERR: Raised if the source node is of type `DOCUMENT`, `DOCUMENT_TYPE`.
        NO_MODIFICATION_ALLOWED_ERR: Raised when the source node is readonly.

    - #### normalizeDocument

          public void normalizeDocument()

      DOM Level 3
      Specified by:
        `normalizeDocument` in interface `org.w3c.dom.Document`

    - #### getDomConfig

          public org.w3c.dom.DOMConfiguration getDomConfig()

      The configuration used when `Document.normalizeDocument` is invoked.
      Specified by:
        `getDomConfig` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### renameNode

          public org.w3c.dom.Node renameNode(org.w3c.dom.Node n,
                                    java.lang.String namespaceURI,
                                    java.lang.String name)
                                      throws org.w3c.dom.DOMException

      DOM Level 3
      Specified by:
        `renameNode` in interface `org.w3c.dom.Document`
      Parameters:
        `n` - The node to rename.
        `namespaceURI` - The new namespace URI.
        `name` - The new qualified name.
      Returns:
        The renamed node. This is either the specified node or the new node that was created to replace the specified node.
      Throws:
        `org.w3c.dom.DOMException` - NOT_SUPPORTED_ERR: Raised when the type of the specified node is neither `ELEMENT_NODE` nor `ATTRIBUTE_NODE`, or if the implementation does not support the renaming of the document element.
        INVALID_CHARACTER_ERR: Raised if the new qualified name is not an XML name according to the XML version in use specified in the `Document.xmlVersion` attribute.
        WRONG_DOCUMENT_ERR: Raised when the specified node was created from a different document than this document.
        NAMESPACE_ERR: Raised if the `qualifiedName` is a malformed qualified name, if the `qualifiedName` has a prefix and the `namespaceURI` is `null`, or if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is different from " http://www.w3.org/XML/1998/namespace" [XML Namespaces] . Also raised, when the node being renamed is an attribute, if the `qualifiedName`, or its prefix, is "xmlns" and the `namespaceURI` is different from "http://www.w3.org/2000/xmlns/".

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.